import React from "react";
/**
 * Format bytes as human-readable text.
 *
 * @param bytes Number of bytes.
 * @param si True to use metric (SI) units, aka powers of 1000. False to use
 *           binary (IEC), aka powers of 1024.
 * @param dp Number of decimal places to display.
 *
 * @return Formatted string.
 */
declare function formatFileSize(bytes: number, si?: boolean, dp?: number): string;
declare function formatDatetime(date: Date, format?: string): string;
interface FileIconFormatterProps {
    fileType: string;
}
declare const FileIconFormatter: React.FC<FileIconFormatterProps>;
export { formatFileSize, formatDatetime, FileIconFormatter };
